<?php

namespace Clever\PaymentGateway\Controller\Order;

use Magento\Framework\App\Action\Action;

/**
 * Class GetCleverPayUrl
 * @package Clever\PaymentGateway\Controller\Order
 */
class GetCleverPayUrl extends Action
{
    /**
     * @var \Magento\Sales\Api\OrderRepositoryInterface
     */
    protected $orderRepository;

    /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
    protected $jsonFactory;

    /**
     * GetCleverPayUrl constructor.
     * @param \Magento\Framework\Controller\Result\JsonFactory $jsonFactory
     * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
     * @param \Magento\Framework\App\Action\Context $context
     */
    public function __construct(
        \Magento\Framework\Controller\Result\JsonFactory $jsonFactory,
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository,
        \Magento\Framework\App\Action\Context $context
    ) {
        parent::__construct($context);
        $this->orderRepository = $orderRepository;
        $this->jsonFactory = $jsonFactory;
    }

    /**
     * {@inheritDoc}
     */
    public function execute()
    {
        $orderId = $this->getRequest()->getParam('order_id');
        $order = $this->orderRepository->get($orderId);
        $result = $this->jsonFactory->create();
        $result->setData($order->getPayment()->getAdditionalInformation('clever_pay_url'));
        return $result;
    }
}
