<?php

namespace Clever\PaymentGateway\Gateway\Config;

/**
 * Class Config
 * @package Clever\PaymentGateway\Gateway\Config
 */
class Config extends \Magento\Payment\Gateway\Config\Config
{
    const IS_SANDBOX = 'is_sandbox';

    private $_attribute = [
        'app_id',
        'secret_key'
    ];

    /**
     * Config constructor.
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     * @param null $methodCode
     * @param string $pathPattern
     */
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        $methodCode = null,
        $pathPattern = \Magento\Payment\Gateway\Config\Config::DEFAULT_PATH_PATTERN
    ) {
        \Magento\Payment\Gateway\Config\Config::__construct($scopeConfig, $methodCode, $pathPattern);
    }

    /**
     * @param string $field
     * @param null $storeId
     * @return mixed|null
     */
    public function getValue($field, $storeId = null)
    {
        if (in_array($field, $this->_attribute) && parent::getValue(self::IS_SANDBOX, $storeId)) {
            return parent::getValue($field.'_test', $storeId);
        }
        return parent::getValue($field, $storeId);
    }
}
