<?php

namespace Clever\PaymentGateway\Model\Ui;

use Magento\Checkout\Model\ConfigProviderInterface;

/**
 * Class ConfigProvider
 * @package Clever\PaymentGateway\Model\Ui
 */
class ConfigProvider implements ConfigProviderInterface
{
    const CODE = 'clever_pay';

    /**
     * @var \Magento\Payment\Gateway\ConfigInterface
     */
    protected $config;

    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $storeManager;

    /**
     * ConfigProvider constructor.
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param \Magento\Payment\Gateway\ConfigInterface $config
     */
    public function __construct(
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Payment\Gateway\ConfigInterface $config
    ) {
        $this->config             = $config;
        $this->storeManager       = $storeManager;
    }

    /**
     * @return \array[][]
     */
    public function getConfig()
    {
        return [
            'payment' => [
                self::CODE => [
                    'isActive'         => $this->config->getValue('active')
                ],
            ]
        ];
    }
}
