<?php

namespace Clever\PaymentGateway\Plugin\Model\Order\Payment\State;

/**
 * Class OrderCommand
 * @package Clever\PaymentGateway\Plugin\Model\Order\Payment\State
 */
class OrderCommand
{
    /**
     * @param $subject
     * @param \Closure $proceed
     * @param \Magento\Sales\Api\Data\OrderPaymentInterface $payment
     * @param $amount
     * @param \Magento\Sales\Api\Data\OrderInterface $order
     * @return \Magento\Framework\Phrase|mixed
     */
    public function aroundExecute(
        $subject,
        \Closure $proceed,
        \Magento\Sales\Api\Data\OrderPaymentInterface $payment,
        $amount,
        \Magento\Sales\Api\Data\OrderInterface $order
    ) {
        if ($payment->getMethod() == \Clever\PaymentGateway\Model\Ui\ConfigProvider::CODE) {

            $message = 'Ordered amount of %1';

            return __($message, $order->getBaseCurrency()->formatTxt($amount));
        } else return $proceed($payment, $amount, $order);
    }
}
