define([
        'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/model/payment/additional-validators',
        'Magento_Checkout/js/action/redirect-on-success'
    ], function ($, Component, additionalValidators, redirectOnSuccessAction) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'Clever_PaymentGateway/payment/clever-pay',
            },
            cleverLogo: window.checkoutConfig.clever_logo,
            cleverPaymentLogo: window.checkoutConfig.cleverPaymentLogo,
            cleverDescription: window.checkoutConfig.clever_description,
            cleverCart: window.checkoutConfig.clever_cart,
            cleverBank: window.checkoutConfig.clever_bank,
            cleverCoin: window.checkoutConfig.clever_coin,
            cleverCashback: window.checkoutConfig.cashback,
            currencySymbol: window.checkoutConfig.symbol,
            getCode: function () {
                return 'clever_pay';
            },
            placeOrder: function (data, event) {
                var self = this;
                if (event) {
                    event.preventDefault();
                }
                if (this.validate() && additionalValidators.validate()) {
                    this.isPlaceOrderActionAllowed(false);
                    this.getPlaceOrderDeferredObject()
                        .fail(function () {
                            self.isPlaceOrderActionAllowed(true);
                        }).done(function (orderID) {
                            $.ajax({
                                url: window.checkoutConfig.getCleverPayUrl,
                                dataType: "json",
                                type: 'POST',
                                showLoader: true,
                                data: {
                                    order_id: orderID
                                }
                            }).done(function (url) {
                                window.location.replace(url);
                            }).fail(function (err) {
                                console.log(err);
                            });
                            self.afterPlaceOrder();
                        }
                    );
                    return true;
                }
                return false;
            }
        });
    }
);
